/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"encoding/json"
	"fmt"
)

// ResourceCategory the model 'ResourceCategory'
type ResourceCategory string

// List of ResourceCategory
const (
	RESOURCECATEGORY_UNDEFINED ResourceCategory = "Undefined"
	RESOURCECATEGORY_OFFICIAL  ResourceCategory = "Official"
	RESOURCECATEGORY_PERSONAL  ResourceCategory = "Personal"
	RESOURCECATEGORY_TEST      ResourceCategory = "Test"
)

// All allowed values of ResourceCategory enum
var AllowedResourceCategoryEnumValues = []ResourceCategory{
	"Undefined",
	"Official",
	"Personal",
	"Test",
}

func (v *ResourceCategory) UnmarshalJSON(src []byte) error {
	var value string
	err := json.Unmarshal(src, &value)
	if err != nil {
		return err
	}
	enumTypeValue := ResourceCategory(value)
	for _, existing := range AllowedResourceCategoryEnumValues {
		if existing == enumTypeValue {
			*v = enumTypeValue
			return nil
		}
	}

	return fmt.Errorf("%+v is not a valid ResourceCategory", value)
}

// NewResourceCategoryFromValue returns a pointer to a valid ResourceCategory
// for the value passed as argument, or an error if the value passed is not allowed by the enum
func NewResourceCategoryFromValue(v string) (*ResourceCategory, error) {
	ev := ResourceCategory(v)
	if ev.IsValid() {
		return &ev, nil
	} else {
		return nil, fmt.Errorf("invalid value '%v' for ResourceCategory: valid values are %v", v, AllowedResourceCategoryEnumValues)
	}
}

// IsValid return true if the value is valid for the enum, false otherwise
func (v ResourceCategory) IsValid() bool {
	for _, existing := range AllowedResourceCategoryEnumValues {
		if existing == v {
			return true
		}
	}
	return false
}

// Ptr returns reference to ResourceCategory value
func (v ResourceCategory) Ptr() *ResourceCategory {
	return &v
}

type NullableResourceCategory struct {
	value *ResourceCategory
	isSet bool
}

func (v NullableResourceCategory) Get() *ResourceCategory {
	return v.value
}

func (v *NullableResourceCategory) Set(val *ResourceCategory) {
	v.value = val
	v.isSet = true
}

func (v NullableResourceCategory) IsSet() bool {
	return v.isSet
}

func (v *NullableResourceCategory) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableResourceCategory(val *ResourceCategory) *NullableResourceCategory {
	return &NullableResourceCategory{value: val, isSet: true}
}

func (v NullableResourceCategory) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableResourceCategory) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
